//+------------------------------------------------------------------+
//|                                                 e 02-07-2006.mq4 |
//| 22-07-2006 mico's EST TS idea                                    |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Alexander P. aka FinGeR"
#property link      "5one51@googlemail.com"

extern string _P_Expert = "---------- Parameters of the adviser";
extern int    OffSetHour    = 6;     //Displacement of hours
extern bool   UseOneAccount = False;        
extern int    NumberAccount = 0;        
extern string Name_Expert   = "";
extern bool   UseSound      = False;        
extern string NameFileSound = "expert.wav"; 
extern bool   ShowComment   = True; 

extern string _P_Trade = "---------- Parameters of trade";
extern int   HourOpenPos   = 9;
extern int   HourDeletePos = 23;
extern int   HourClosePos  = 23;
extern double Lots         = 1;     
extern int TakeProfit      = 0; 
extern int StopLoss        = 0;        
extern int TrailingStop    = 0; 
extern int Slippage        = 3;     //difference the prices
       int NumberOfTry     = 7;     //Quantity of attempts
       int PauseAfterError = 21;    //the Pause after a mistake in seconds 
      

//---- Global variables of the adviser -------------------------------
color clOpenBuy    = LightBlue;
color clOpenSell   = LightCoral;
color clCloseBuy   = Blue;
color clCloseSell  = Red;
color clModifyBuy  = Aqua;
color clModifySell = Tomato;

//---- external modules ---------------------------------
//#include <b-Lots.mqh>
//#include <b-Orders.mqh> 
#include <stderror.mqh>
#include <stdlib.mqh>

int MAGIC = 830900;


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

//WriteOrdersInfo();         // Cuttings for the analyzer
//WriteDealsInfo();         // On days of week
    
    if (!IsTesting()) Comment("");

}
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  if (!IsTesting()) {
    if (UseOneAccount && AccountNumber()!=NumberAccount) {
      Comment("On the account"+AccountNumber()+"Trade is forbidden!!");
      return;
    } else Comment("");
    if (Period()!=PERIOD_M15) {
      Comment("The adviser "+Name_Expert+" Supports only Timeframe M15!");
      return;
    } else Comment("");
  }
   DeleteOppositeOrders();
  if (Hour()== HourOpenPos+OffSetHour && Minute()< 15 ) SetOrders();

  int realhour=HourDeletePos+OffSetHour;if(realhour>23)realhour=realhour-24;
  
   if (Hour()== realhour) DeleteAllOrders() ;

  realhour=HourClosePos+OffSetHour;if(realhour>23)realhour=realhour-24;
  
    if (Hour()== realhour) CloseAllPositions();
   
   
  
   if (TrailingStop!=0) TrailingPositions();
  

}
  

void SetOrders() {
  double ldStop=0, ldTake=0;
  double  pH=High[Highest(NULL,0,MODE_HIGH,2,1)]+4*Point;
  double  pL=Low[Lowest(NULL,0,MODE_LOW,2,1)]-4*Point;
 


  if (!ExistOrder(1) && !ExistPosition(2)) {
   
    if (StopLoss!=0) ldStop=pH-StopLoss*Point;
    if (TakeProfit!=0) ldTake=pH+TakeProfit*Point;
    
    if( pH-pL<50*Point && (pH-Ask)>5*Point) SetOrder(OP_BUYSTOP, pH, ldStop, ldTake, 1);
    if( (pH-Ask)<5*Point && Ask >= pH) SetOrder(OP_BUY, Ask, ldStop, ldTake, 1);
  }
  
  if (!ExistOrder(2) && !ExistPosition(1)) {
  
    if (StopLoss!=0) ldStop=pL+StopLoss*Point;
    if (TakeProfit!=0) ldTake=pL-TakeProfit*Point;
   
    if( pH-pL<50*Point && (Bid-pL)>5*Point) SetOrder(OP_SELLSTOP, pL, ldStop, ldTake, 2);
    if( (Bid-pL)<5*Point && Bid <= pL) SetOrder(OP_SELL, Bid, ldStop, ldTake, 2);
  }
}



bool ExistOrder(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        Exist=True; break;
      }
    }
  }
  return(Exist);
}


bool ExistPosition(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          Exist=True; break;
        }
      }
    }
  }
  return(Exist);

}
void SetOrder(int op, double pp, double ldStop, double ldTake, int mn) {
  color  clOpen;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUYSTOP) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
 OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC+mn,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}



//+---------------------------------------------------------------------+
//|Generates and returns a line Comment for the warrant or a position   |
//+---------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert+" "+GetNameTF(Period()));
}

  
 
//+------------------------------------------------------------------+
//| Returns the name Timeframe                                       |
//+------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
	switch (TimeFrame) {
		case PERIOD_MN1: return("Monthly");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_D1:  return("Daily");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
}
 

void DeleteOppositeOrders() {
  bool fd, fep1, fep2;

  fep1=ExistPosition(1);
  fep2=ExistPosition(2);

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        fd=False;
        if (OrderType()==OP_BUYSTOP && OrderMagicNumber()==MAGIC+1) {
          if (fep2) fd=OrderDelete(OrderTicket());
        }
        if (OrderType()==OP_SELLSTOP && OrderMagicNumber()==MAGIC+2) {
          if (fep1) fd=OrderDelete(OrderTicket());
        }
        if (fd && UseSound) PlaySound(NameFileSound);
      }
    }
  }
}


void DeleteAllOrders() {
  bool fd;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderMagicNumber()==MAGIC+1 || OrderMagicNumber()==MAGIC+2)) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) {
            fd=OrderDelete(OrderTicket());
            if (fd && UseSound) PlaySound(NameFileSound);
          }
        }
      }
    }
  }
}

 
//+------------------------------------------------------------------+
//| Closing of all positions at the market price                     |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  bool   fc;
  double pp;
  int    err, it;

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && (OrderMagicNumber()==MAGIC+1 || OrderMagicNumber()==MAGIC+2) ) {
        fc=False;
        for (it=1; it<=NumberOfTry; it++) {
          while (!IsTradeAllowed()) Sleep(5000);
          RefreshRates();
          if (OrderType()==OP_BUY) {
            pp=NormalizeDouble(Bid, Digits);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing buy: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
          if (OrderType()==OP_SELL) {
            pp=NormalizeDouble(Ask, Digits);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing sell: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
        }
      }
    }
  }
} 
  
  
//+------------------------------------------------------------------+
//| Support of a position by a simple trailing                       |
//+------------------------------------------------------------------+
void TrailingPositions() {
  int TrailingStep=5;

  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && (OrderMagicNumber()==MAGIC+1 || OrderMagicNumber()==MAGIC+2)) {
        if (OrderType()==OP_BUY) {
          if (Bid-OrderOpenPrice()>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              ModifyStopLoss(Bid-TrailingStop*Point, clModifyBuy);
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              ModifyStopLoss(Ask+TrailingStop*Point, clModifySell);
            }
          }
        }
      }
    }
  }
}
  
  
//+------------------------------------------------------------------+
//| Carry of a level StopLoss                                        |
//| Parameters:                                                      |
//|   ldStopLoss - Level StopLoss                                    |
//|   clModify   - Color of updating                                 |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop, color clModify) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();
  int    err;

  if (IsTradeAllowed()) {
    fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
    if (!fm) {
      err=GetLastError();
      Print("Error(",err,") modifying SL: ",err);
    }
  }
} 


